using HermesSocketServer.Models;
using HermesSocketServer.Store;
using ILogger = Serilog.ILogger;

namespace HermesSocketServer.Requests
{
    public class DeleteTTSVoice : IRequest
    {
        public string Name => "delete_tts_voice";
        public string[] RequiredKeys => ["voice"];
        private IStore<string, Voice> _voices;
        private ILogger _logger;

        public DeleteTTSVoice(VoiceStore voices, ILogger logger)
        {
            _voices = voices;
            _logger = logger;
        }

        public async Task<RequestResult> Grant(string sender, IDictionary<string, object>? data)
        {
            _voices.Remove(data!["voice"].ToString());
            _logger.Information($"Deleted a voice by id [voice id: {data["voice"]}]");
            return RequestResult.Successful(null);
        }
    }
}