namespace HermesSocketServer.Store
{
    public interface IStore<K, V>
    {
        V? Get(K key);
        IDictionary<K, V> Get();
        Task Load();
        bool Modify(K? key, Action<V> action);
        void Remove(K? key);
        Task<bool> Save();
        bool Set(K? key, V? value);
    }
}